/****************************************************************************
                  INTERNATIONAL AVS CENTER
	(This disclaimer must remain at the top of all files)

WARRANTY DISCLAIMER

This module and the files associated with it are distributed free of charge.
It is placed in the public domain and permission is granted for anyone to use,
duplicate, modify, and redistribute it unless otherwise noted.  Some modules
may be copyrighted.  You agree to abide by the conditions also included in
the AVS Licensing Agreement, version 1.0, located in the main module
directory located at the International AVS Center ftp site and to include
the AVS Licensing Agreement when you distribute any files downloaded from 
that site.

The International AVS Center, MCNC, the AVS Consortium and the individual
submitting the module and files associated with said module provide absolutely
NO WARRANTY OF ANY KIND with respect to this software.  The entire risk as to
the quality and performance of this software is with the user.  IN NO EVENT
WILL The International AVS Center, MCNC, the AVS Consortium and the individual
submitting the module and files associated with said module BE LIABLE TO
ANYONE FOR ANY DAMAGES ARISING FROM THE USE OF THIS SOFTWARE, INCLUDING,
WITHOUT LIMITATION, DAMAGES RESULTING FROM LOST DATA OR LOST PROFITS, OR ANY
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES.

This AVS module and associated files are public domain software unless
otherwise noted.  Permission is hereby granted to do whatever you like with
it, subject to the conditions that may exist in copyrighted materials. Should
you wish to make a contribution toward the improvement, modification, or
general performance of this module, please send us your comments:  why you
liked or disliked it, how you use it, and most important, how it helps your
work. We will receive your comments at avs@ncsc.org.

Please send AVS module bug reports to avs@ncsc.org.

******************************************************************************/
#include <avs/flow.h>
#include <avs/avs_data.h>
#include <avs/field.h>

/******************************************************************************/

/* 
 * This is a C example to compute the difference of the input port-- hence the
 * name delta. Its _very_ simple, but extremely usefull. 
 */  

AVSinit_modules()
{
	int delta_int();

	AVSmodule_from_desc(delta_int);
}

/*  The routine "delta_int" is the description routine.  */

delta_int()
{
	int delta_int_compute();	/* declare the compute function (below) */
	int in_port, out_port;	/* temporaries to hold the port numbers */

	/* Set the module name and type */
	AVSset_module_name("Delta_Int", MODULE_FILTER);

	/* Create an input port for the required field input */
	in_port =
		AVScreate_input_port("Input_Int",
				     "integer", REQUIRED);

	/* Create an output port for the result */
	out_port = AVScreate_output_port("Output_Int",
					 "integer");

	/* Tell AVS to allocate space for the output data based on the size */
	/* of the input data - note that this only works when the output */
	/* port has the same type as the input port */
	AVSautofree_output(out_port);

      /* AVSinitialize_output(in_port, out_port);   */

	AVSadd_parameter("Delta_int","integer",1,-200,200);

	/* Tell avs what subroutine to call to do the compute */
	AVSset_compute_proc(delta_int_compute);
}

/*
 */

static delta_int_compute(input, output, delta_int)
int *input, **output;
int delta_int;
{
  int IN, OUT;

/* This can be simplified I'm sure, but I just incase I'll do it this way. */
	IN = (int)input;
	input  = (int *)malloc(sizeof(int));	
	*output = (int *)malloc(sizeof(int));	
	OUT = (int)( IN + delta_int);
	*output = (int *)OUT;

    /* When we're done, we return 1 to indicate success */
    return(1);
}
